<?php
/*
Plugin Name: Intégration Scoopeo
Plugin URI: http://lapin-blanc.net/category/scoopeo/
Description: Intégration du digg-like francophone Scoopeo dans Wordpress. Ce plugin permet de voter directement depuis les articles et liste les commentaires postés à leurs propos sur Scoopeo.
Author: Kévin Dunglas
Version: 0.3
Author URI: http://lapin-blanc.net/
*/

/*  Copyright 2008  Kévin Dunglas  (email : dunglas@gmail.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


function scoopeo_comments () {
    global $wp_query;
    global $wp_locale;
    
    $click = 'http://www.scoopeo.com/clicker/cl_large/';
    $rss = 'http://www.scoopeo.com/scoop/rss2/';
    $user = 'http://www.scoopeo.com/membre/';
    
    $post = $wp_query->post;
    $permalink = get_permalink ($post->ID);

    /* Encode URLs like needed to get the article's associated Scoopeo clicker */
    $chars = array ('.', '/', '?');
    $part1 = urlencode (str_replace ($chars, '-', $permalink));
    $part2 = urlencode ($permalink);

    /* Get the HTML code of the clicker */
    $clicker = $click . $part1 . '?url=' . $part2;
    if(!($file = @file_get_contents ($clicker))) return;
    
    /* Get the article's Scoopeo ID */
    $reg = '/<a[^>]+href="([^"¦\'>]+)?clic=([0-9]+)">/i';
    $m = array();
    preg_match_all($reg, $file, $m);
    if (array_key_exists (2, $m) && array_key_exists (0, $m[2])) $id = $m[2][0];
    else return;

    /* Load the Scoopeo RSS feed associated with the article */
    if (!($xml = @simplexml_load_file($rss . $id))) return;
    $items = $xml->channel->item;
    if (count ($items) == 0) return;


    $out = '<div id="scoopeo-comments" class="comments">
  <div class="comments-content">
  <h3 class="comments-header">Commentaires Scoopeo</h3>';
  
    $i = 0;
    foreach ($xml->channel->item as $item) {
            $time = strtotime ($item->pubDate);
            $date = date ('j F Y H:i', $time);
            if (!empty ($wp_locale->month)) {
                $datemonth = $wp_locale->get_month(date('m', $time));
                $date = preg_replace('/(\d+) (\w+) (\d+) (\d+):(\d+)/i', '$1 ' . $datemonth . ' $3 $4:$5', $date);
            }
            $tmp[] .= '<div class="comment" id="scoopeo-comment-' . ($i + 1) . '">
      <div class="comment-content">
        <p>' . $item->description . '</p>
      </div>

      <p class="comment-footer">Ecrit par : <a href="' . $user . urlencode ($item->author) . '" rel="external nofollow">' . htmlspecialchars ($item->author) . '</a> | <a href="#scoopeo-comment-' . $i . '">' . $date . '</a></p>
    </div>';
    $i++;
    }
    
    /* Reverse the order of comments (first posted, first displayed) */
    for ($i = count ($tmp); $i > 0; $i--) {
        $out .= $tmp[$i - 1];
    }
    
    $out .= '<span class="scoopeo-author">via <a href="http://lapin-blanc.net">Lapin Blanc</a>...</span></div>
</div>';
    
    return $out;
}

function scoopeo_clicker () {
    global $wp_query;

    $post = $wp_query->post;
    $permalink = get_permalink ($post->ID);

    $out = '<div class="scoopeo">';
    $out .= '<script type="text/javascript">scoopeo_url=\'' . $permalink . '\'</script>';
    $out .= '<script type="text/javascript" src="http://scoopeo.com/clicker/insert/large"></script>';
    $out .= '</div>';
    
    return $out;
}

function the_scoopeo_clicker () {
    echo scoopeo_clicker ();
}

function the_scoopeo_comments () {
    echo scoopeo_comments ();
}

//add_filter ('the_content', 'scoopeo_clicker'); 
?>